#include "testlib.h"
#include <iostream>
#include <numeric>

using namespace std;


int get_finish(const vector <int>& a, int t, int start) {
    int ans = 0, fin = start;
    int dist = 0;
    for (int end = start; end >= 0; end--) {
        int now = (t - dist) / a[end] + (start - end);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    dist = 0;
    for (int end = start; end < a.size(); end++) {
        int now = (t - dist) / a[end] + (end - start);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    return fin;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1);
    int starts_start = opt<int>(2);
    vector <int> x;
    for (int i = 1; i <= n; i++) {
        x.push_back(i);
        x.push_back(i);
        x.push_back(i);
        x.push_back(i);
        x.push_back(i);
        x.push_back(i);
    }
    shuffle(x.begin(), x.end());
    x.erase(x.begin() + n, x.end());
    sort(x.begin(), x.end());

    vector <int> starts;
    for (int i = starts_start; i < n; i++) {
        starts.push_back(i);
    }
    shuffle(starts.begin(), starts.end());
    starts.erase(starts.begin(), starts.begin() + starts.size() / 5);
    sort(starts.begin(), starts.end());

    println(n, starts.size(), rnd.next(1LL, min(1'000'000'000LL, (long long) starts_start * n)));
    println(x);
    sort(starts.begin(), starts.end());
    println(starts);
}
