#include "testlib.h"
#include <iostream>
#include <numeric>

using namespace std;


int get_finish(const vector <int>& a, int t, int start) {
    int ans = 0, fin = start;
    int dist = 0;
    for (int end = start; end >= 0; end--) {
        int now = (t - dist) / a[end] + (start - end);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    dist = 0;
    for (int end = start; end < a.size(); end++) {
        int now = (t - dist) / a[end] + (end - start);
        if (now > ans) {
            ans = now;
            fin = end;
        }
        dist += a[end];
        if (dist >= t) {
            break;
        }
    }
    return fin;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1);

    vector <int> x(n);
    for (int& i : x) {
        i = rnd.next(1, 5);
    }
    vector <int> starts;
    for (int i = 0; i < n; i++) {
        int fin = get_finish(x, 20, i);
        if (abs(fin - i) > 3) {
            starts.push_back(i);
        }
    }
    println(n, starts.size(), 20);
    println(x);
    sort(starts.begin(), starts.end());
    println(starts);
}
