#include <bits/stdc++.h>

#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;

using namespace std;

void solve() {
    // (cur - stay) + (T - (pref[cur] - pref[stay])) // a[stay]
    // get min from A + (B - x) / C ?
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }
    int ans = 0;
    auto update = [&](int from, int to) {
        if (from >= to) {
            if (pref[from + 1] - pref[to + 1] <= T)
                ans = max<int>(ans, (from - to) + (T - (pref[from + 1] - pref[to + 1])) / a[to]);
        } else {
            if (pref[to] - pref[from] <= T)
                ans = max<int>(ans, (to - from) + (T - (pref[to] - pref[from])) / a[to]);
        }
    };
    for (int i = 0; i < n; ++i) {
        if (lower_bound(all(b), i) != b.end()) {
            update(*lower_bound(all(b), i), i);
        }
        if (lower_bound(all(b), i) != b.begin()) {
            update(*--lower_bound(all(b), i), i);
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    //freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}
