#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

#define double ld
// #define MT // MULTITEST

void solve() {
    int n, m, T;
    cin >> n >> m >> T;

    vector<int> a(n);
    for (auto &el : a) cin >> el;

    vector<int> b(m);
    for (auto &el : b) cin >> el, --el;

    auto solve_part = [&] () {
        vector<ll> pref(n + 1);
        for (int i = 0; i < n; ++i) pref[i + 1] = pref[i] + a[i];

        vector<ll> ans(n, 0);
        for (int i = 0; i < n; ++i) {
            ans[i] = max<ll>(ans[i], T / a[i]);
            for (int j = i - 1; j >= 0; --j) {
                if (T - pref[i + 1] + pref[j + 1] < 0) {
                    break;
                }

                ans[i] = max<ll>(ans[i], (T - pref[i + 1] + pref[j + 1]) / a[j] - j + i);
            }
        }

        ll answer = 0;
        for (auto el : b) {
            answer = max(answer, ans[el]);
        }
        return answer;
    };

    ll answer = solve_part();

    auto rev = [&] () {
        reverse(all(a));
        for (auto &el : b) {
            el = n - 1 - el;
        }
    };

    rev();
    answer = max(answer, solve_part());

    cout << answer;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef ONPC
    assert(freopen("input.txt", "r", stdin));
    assert(freopen("output.txt", "w", stdout));
#endif

    int TT = 1;
#ifdef MT
    cin >> TT;
#endif
    while (TT--) {
        solve();
    }
#ifdef ONPC
    std::cerr << "Time(ms): " << 1000 * clock() / CLOCKS_PER_SEC << std::endl;
#endif
    return 0;
}
