#include <bits/stdc++.h>

#define ll long long
using namespace std;

vector <int> gen_smaller(const vector <int>& a) {
    vector <pair <int, int>> st = {{-1, -1}};
    vector <int> ans(a.size());
    for (int i = 0; i < a.size(); i++) {
        while (a[i] <= st.back().first) {
            st.pop_back();
        }
        ans[i] = st.back().second;
        st.emplace_back(a[i], i);
    }
    return ans;
}


signed main() {
    ios_base::sync_with_stdio();
    cin.tie(nullptr);

    int n, m, t;
    cin >> n >> m >> t;

    vector<int> a(n), b(m);
    for (int &i: a) {
        cin >> i;
    }
    for (int & i : b) {
        cin >> i;
        i--;
    }

    vector <int> pre_smaller = gen_smaller(a);
    reverse(a.begin(), a.end());
    vector <int> post_smaller = gen_smaller(a);
    reverse(a.begin(), a.end());
    reverse(post_smaller.begin(), post_smaller.end());
    for (int& i : post_smaller) {
        if (i != -1) {
            i = n - i - 1;
        }
    }
    vector <int> pref_sum(n + 1);
    for (int i = 0; i < n; i++) {
        pref_sum[i + 1] = pref_sum[i] + a[i];
    }

    int ans = 0;
    for (int i : b) {
        if (static_cast<double>(clock()) / CLOCKS_PER_SEC > 0.9) {
            break;
        }
        int end = i;
        while (end != -1) {
            int dist = pref_sum[i + 1] - pref_sum[end + 1];
            if (dist <= t) {
                ans = max(ans, (t - dist) / a[end] + (i - end));
            }
            end = pre_smaller[end];
        }
        end = i;
        while (end != -1) {
            int dist = pref_sum[end] - pref_sum[i];
            if (dist <= t) {
                ans = max(ans, (t - dist) / a[end] + (end - i));
            }
            end = post_smaller[end];
        }
    }
    cout << ans << endl;
    return 0;
}
