#include <bits/stdc++.h>

#define ll long long
using namespace std;


signed main() {
    ios_base::sync_with_stdio();
    cin.tie(nullptr);

    int n, m, t;
    cin >> n >> m >> t;

    vector<int> a(n), b(m);
    for (int &i: a) {
        cin >> i;
    }
    for (int & i : b) {
        cin >> i;
        i--;
    }

    vector <ll> pref_sum(n + 1);
    for (int i = 1; i <= n; i++) {
        pref_sum[i] = pref_sum[i - 1] + a[i - 1];
    }

    ll ans = 0;
    int right = 0;
    for (int end_point = 0; end_point < n; end_point++) {
        if (right != m) {  // check runner on the right
            ll dist = pref_sum[b[right] + 1] - pref_sum[end_point + 1];
            if (dist <= t) {
                ans = max(ans, b[right] - end_point + (t - dist) / a[end_point]);
            }
        }
        if (b[right] == end_point) {
            right++;
        }
    }
    cout << ans << endl;
    return 0;
}
